searchData={"items":[{"type":"module","title":"Kaffy.Cache.Client","doc":"","ref":"Kaffy.Cache.Client.html"},{"type":"function","title":"Kaffy.Cache.Client.add_cache/4","doc":"","ref":"Kaffy.Cache.Client.html#add_cache/4"},{"type":"function","title":"Kaffy.Cache.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Kaffy.Cache.Client.html#child_spec/1"},{"type":"function","title":"Kaffy.Cache.Client.get_cache/2","doc":"","ref":"Kaffy.Cache.Client.html#get_cache/2"},{"type":"function","title":"Kaffy.Cache.Client.start_link/1","doc":"","ref":"Kaffy.Cache.Client.html#start_link/1"},{"type":"module","title":"Kaffy.Inflector","doc":"Module holding functions related to inflection of words. It does not attempt to\nbe perfect, rather aiming at being \"good enough\".","ref":"Kaffy.Inflector.html"},{"type":"function","title":"Kaffy.Inflector.pluralize/1","doc":"Attempts to create a correct plural version by following rules outlined at:\nhttps://www.grammarly.com/blog/plural-nouns/\n\nSome of these rules are conscously ommited as being rare and hard to implement.","ref":"Kaffy.Inflector.html#pluralize/1"},{"type":"module","title":"Kaffy.ResourceAdmin","doc":"ResourceAdmin modules should be created for every schema you want to customize/configure in Kaffy.\n\nIf you have a schema like `MyApp.Products.Product`, you should create an admin module with\nname `MyApp.Products.ProductAdmin` and add functions documented in this module to customize the behavior.\n\nAll functions are optional.","ref":"Kaffy.ResourceAdmin.html"},{"type":"function","title":"Kaffy.ResourceAdmin.authorized?/2","doc":"`authorized?/2` takes the schema and the current Plug.Conn struct and\nshould return a boolean value.\n\nReturning false will prevent the access of this resource for the current user/request.\n\nIf `authorized?/2` is not defined, Kaffy will return true.","ref":"Kaffy.ResourceAdmin.html#authorized?/2"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.authorized?/2","doc":"```elixir\ndef authorized?(_schema, _conn) do\n  true\nend\n```","ref":"Kaffy.ResourceAdmin.html#authorized?/2-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.collect_links/2","doc":"","ref":"Kaffy.ResourceAdmin.html#collect_links/2"},{"type":"function","title":"Kaffy.ResourceAdmin.collect_pages/1","doc":"","ref":"Kaffy.ResourceAdmin.html#collect_pages/1"},{"type":"function","title":"Kaffy.ResourceAdmin.collect_widgets/2","doc":"","ref":"Kaffy.ResourceAdmin.html#collect_widgets/2"},{"type":"function","title":"Kaffy.ResourceAdmin.create_changeset/2","doc":"`create_changeset/2` takes the record and the changes and should return a changeset for creating a new record.\n\nIf `create_changeset/2` is not defined, Kaffy will try to call `schema.changeset/2`\n\nand if that's not defined, `Ecto.Changeset.change/2` will be called.","ref":"Kaffy.ResourceAdmin.html#create_changeset/2"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.create_changeset/2","doc":"```elixir\ndef create_changeset(schema, attrs) do\n  MyApp.Blog.Post.create_changeset(schema, attrs)\nend\n```","ref":"Kaffy.ResourceAdmin.html#create_changeset/2-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.custom_index_query/3","doc":"","ref":"Kaffy.ResourceAdmin.html#custom_index_query/3"},{"type":"function","title":"Kaffy.ResourceAdmin.custom_links/2","doc":"","ref":"Kaffy.ResourceAdmin.html#custom_links/2"},{"type":"function","title":"Kaffy.ResourceAdmin.custom_pages/2","doc":"","ref":"Kaffy.ResourceAdmin.html#custom_pages/2"},{"type":"function","title":"Kaffy.ResourceAdmin.custom_show_query/3","doc":"","ref":"Kaffy.ResourceAdmin.html#custom_show_query/3"},{"type":"function","title":"Kaffy.ResourceAdmin.default_actions/1","doc":"`default_actions/1` takes a schema and returns the default actions for the schema.\n\nIf `default_actions/1` is not defined, Kaffy will return `[:new, :edit, :delete]`.\n\nExample:\n\n```elixir\ndef default_actions(_schema) do\n  [:new, :delete]\nend\n```","ref":"Kaffy.ResourceAdmin.html#default_actions/1"},{"type":"function","title":"Kaffy.ResourceAdmin.deserialize_id/2","doc":"`deserialize_id/2` takes a schema and serialized id and must return a complete\nkeyword list in the form of [{:primary_key, value}, ...].\n\nIf `deserialize_id/2` is not defined, Kaffy will split multiple primary keys with `\":\"` as a separator.\n\nExamples:\n\n```elixir\n# Default method with fixed keys\ndef deserialize_id(_schema, serialized_id) do\n  Enum.zip([:post_id, :tag_id], String.split(serialized_id, \":\"))\nend\n\n# Deserialize from ETF\ndef deserialize_id(_schema, serialized_id) do\n  {product_id, tag_id} = serialized_id\n  |> Base.url_decode64!()\n  |> :erlang.binary_to_term()\n\n  [product_id: product_id, tag_id: tag_id]\nend\n```","ref":"Kaffy.ResourceAdmin.html#deserialize_id/2"},{"type":"function","title":"Kaffy.ResourceAdmin.find_page/2","doc":"","ref":"Kaffy.ResourceAdmin.html#find_page/2"},{"type":"function","title":"Kaffy.ResourceAdmin.form_fields/1","doc":"form_fields/1 takes a schema and returns a keyword list of fields and their options for the new/edit form.\n\nSupported options are:\n\n`:label`, `:type`, `:choices`, and `:permission`\n\n`:type` can be any ecto type in addition to `:file` and `:textarea`\n\nIf `:choices` is provided, it must be a keyword list and\nthe field will be rendered as a ` ` element regardless of the actual field type.\n\nSetting `:permission` to `:read` will make the field non-editable. It is `:write` by default.\n\nIf you want to remove a field from being rendered, just remove it from the list.\n\nIf form_fields/1 is not defined, Kaffy will return all the fields with\ntheir default types based on the schema.","ref":"Kaffy.ResourceAdmin.html#form_fields/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.form_fields/1","doc":"```elixir\ndef form_fields(_schema) do\n  [\n    title: %{label: \"Subject\"},\n    slug: nil,\n    image: %{type: :file},\n    status: %{choices: [{\"Pending\", \"pending\"}, {\"Published\", \"published\"}]},\n    body: %{type: :textarea, rows: 3},\n    views: %{permission: :read}\n  ]\nend\n```","ref":"Kaffy.ResourceAdmin.html#form_fields/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.humanize_term/1","doc":"","ref":"Kaffy.ResourceAdmin.html#humanize_term/1"},{"type":"function","title":"Kaffy.ResourceAdmin.index/1","doc":"`index/1` takes the schema module and should return a keyword list of fields and\ntheir options.\n\nSupported options are `:name` and `:value`.\n\nBoth options can be a string or an anonymous function.\n\nIf a function is provided, the current entry is passed to it.\n\nIf index/1 is not defined, Kaffy will return all the fields of the schema and their default values.","ref":"Kaffy.ResourceAdmin.html#index/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.index/1","doc":"```elixir\ndef index(_schema) do\n  [\n    id: %{name: \"ID\", value: fn post -> post.id + 100 end},\n    title: nil, # this will render the default name for this field (Title) and its default value (post.title)\n    views: %{name: \"Hits\", value: fn post -> post.views + 10 end},\n    published: %{name: \"Published?\", value: fn post -> published?(post) end},\n    comment_count: %{name: \"Comments\", value: fn post -> comment_count(post) end}\n  ]\nend\n```","ref":"Kaffy.ResourceAdmin.html#index/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.index_description/1","doc":"Allows a description to be injected into the index view of a resource's index\nview. This is helpful when you want to provide information to the user about the index page.\nReturn value can be a string, or {:safe, string) tuple.  If :safe tuple is used, HTML will be rendered.\n\n`index_description/1` takes a schema and must return a `String.t()` or tuple `{:safe, String.t()}`.\n\nIf `index_description/1` is not defined, Kaffy will return nil.","ref":"Kaffy.ResourceAdmin.html#index_description/1"},{"type":"function","title":"Examples: - Kaffy.ResourceAdmin.index_description/1","doc":"```elixir\ndef index_description(resource) do\n  \"This will show up on the index page.\"\nend\n\ndef index_description(resource) do\n  {:safe, \"This will show up on the index page.   This will be bold! .\"}\nend\n```","ref":"Kaffy.ResourceAdmin.html#index_description/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.list_actions/2","doc":"","ref":"Kaffy.ResourceAdmin.html#list_actions/2"},{"type":"function","title":"Kaffy.ResourceAdmin.ordering/1","doc":"`ordering/1` takes a schema and returns how the entries should be ordered.\n\nIf `ordering/1` is not defined, Kaffy will return `[desc: primary_key]`, or the first field of the primary key, if it's a composite.","ref":"Kaffy.ResourceAdmin.html#ordering/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.ordering/1","doc":"```elixir\ndef ordering(_schema) do\n  [asc: :title]\nend\n```","ref":"Kaffy.ResourceAdmin.html#ordering/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.plural_name/1","doc":"This is useful for names that cannot be plural by adding an \"s\" at the end.\n\nLike \"Category\" => \"Categories\" or \"Person\" => \"People\".\n\nIf `plural_name/1` is not defined, Kaffy will use the singular\nname and add an \"s\" to it (e.g. Posts).","ref":"Kaffy.ResourceAdmin.html#plural_name/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.plural_name/1","doc":"```elixir\ndef plural_name(_schema) do\n  \"Categories\"\nend\n```","ref":"Kaffy.ResourceAdmin.html#plural_name/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.resource_actions/2","doc":"","ref":"Kaffy.ResourceAdmin.html#resource_actions/2"},{"type":"function","title":"Kaffy.ResourceAdmin.search_fields/1","doc":"`search_fields/1` takes a schema and must return a list of `:string`, ':id`, `:integer`, and `:decimal` fields to search against when typing in the search box.\n\nIf `search_fields/1` is not defined, Kaffy will return all the fields of the schema with the supported types mentioned earlier.","ref":"Kaffy.ResourceAdmin.html#search_fields/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.search_fields/1","doc":"```elixir\ndef search_fields(_schema) do\n  [:id, :title, :slug, :body, :price, :quantity]\nend\n```","ref":"Kaffy.ResourceAdmin.html#search_fields/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.serialize_id/2","doc":"`serialize_id/2` takes a schema and record and must return a string to be used in the URL and form values.\n\nIf `serialize_id/2` is not defined, Kaffy will concatenate multiple primary keys with `\":\"` as a separator.\n\nExamples:\n\n```elixir\n# Default method with fixed keys\ndef serialize_id(_schema, record) do\n  Enum.join([record.post_id, record.tag_id], \":\")\nend\n\n# ETF\ndef serialize_id(_schema, record) do\n  {record.post_id, record.tag_id}\n  |> :erlang.term_to_binary()\n  |> Base.url_encode64()\nend\n```","ref":"Kaffy.ResourceAdmin.html#serialize_id/2"},{"type":"function","title":"Kaffy.ResourceAdmin.singular_name/1","doc":"This function should return a string for the singular name of a resource.\n\nIf `singular_name/1` is not defined, Kaffy will use the name of\nthe last part of the schema module (e.g. Post in MyApp.Blog.Post)\n\nThis is useful for when you have a schema but you want to display its name differently.\n\nIf you have \"Post\" and you want to display \"Article\" for example.","ref":"Kaffy.ResourceAdmin.html#singular_name/1"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.singular_name/1","doc":"```elixir\ndef singular_name(_schema) do\n  \"Article\"\nend\n```","ref":"Kaffy.ResourceAdmin.html#singular_name/1-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.update_changeset/3","doc":"`update_changeset/2` takes the record and the changes and should return a changeset for updating an existing record.\n\nIf `update_changeset/2` is not defined, Kaffy will try to call `schema.changeset/2`\n\nand if that's not defined, `Ecto.Changeset.change/2` will be called.","ref":"Kaffy.ResourceAdmin.html#update_changeset/3"},{"type":"function","title":"Examples - Kaffy.ResourceAdmin.update_changeset/3","doc":"```elixir\ndef update_changeset(schema, attrs) do\n  MyApp.Blog.Post.create_changeset(schema, attrs)\nend\n```","ref":"Kaffy.ResourceAdmin.html#update_changeset/3-examples"},{"type":"function","title":"Kaffy.ResourceAdmin.widgets/2","doc":"","ref":"Kaffy.ResourceAdmin.html#widgets/2"},{"type":"module","title":"Kaffy.ResourceError","doc":"","ref":"Kaffy.ResourceError.html"},{"type":"function","title":"Kaffy.ResourceError.display_errors/2","doc":"","ref":"Kaffy.ResourceError.html#display_errors/2"},{"type":"function","title":"Kaffy.ResourceError.form_error_border_class/2","doc":"","ref":"Kaffy.ResourceError.html#form_error_border_class/2"},{"type":"module","title":"Kaffy.ResourceForm","doc":"","ref":"Kaffy.ResourceForm.html"},{"type":"function","title":"Kaffy.ResourceForm.bare_form_field/3","doc":"","ref":"Kaffy.ResourceForm.html#bare_form_field/3"},{"type":"function","title":"Kaffy.ResourceForm.form_field/4","doc":"","ref":"Kaffy.ResourceForm.html#form_field/4"},{"type":"function","title":"Kaffy.ResourceForm.form_help_text/1","doc":"","ref":"Kaffy.ResourceForm.html#form_help_text/1"},{"type":"function","title":"Kaffy.ResourceForm.form_label/2","doc":"","ref":"Kaffy.ResourceForm.html#form_label/2"},{"type":"function","title":"Kaffy.ResourceForm.form_label_string/1","doc":"","ref":"Kaffy.ResourceForm.html#form_label_string/1"},{"type":"function","title":"Kaffy.ResourceForm.get_field_error/2","doc":"","ref":"Kaffy.ResourceForm.html#get_field_error/2"},{"type":"function","title":"Kaffy.ResourceForm.kaffy_input/5","doc":"","ref":"Kaffy.ResourceForm.html#kaffy_input/5"},{"type":"module","title":"Kaffy.ResourceParams","doc":"","ref":"Kaffy.ResourceParams.html"},{"type":"function","title":"Kaffy.ResourceParams.decode_map_fields/3","doc":"","ref":"Kaffy.ResourceParams.html#decode_map_fields/3"},{"type":"module","title":"Kaffy.Routes","doc":"Kaffy.Routes must be \"used\" in your Phoenix routes:\n\n```elixir\nuse Kaffy.Routes, scope: \"/admin\", pipe_through: [:browser, :authenticate]\n```\n\n`:scope` defaults to `\"/admin\"`\n\n`:pipe_through` defaults to kaffy's `[:kaffy_browser]`","ref":"Kaffy.Routes.html"},{"type":"module","title":"Kaffy.Scheduler.Supervisor","doc":"","ref":"Kaffy.Scheduler.Supervisor.html"},{"type":"function","title":"Kaffy.Scheduler.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Kaffy.Scheduler.Supervisor.html#child_spec/1"},{"type":"function","title":"Kaffy.Scheduler.Supervisor.start_link/1","doc":"","ref":"Kaffy.Scheduler.Supervisor.html#start_link/1"},{"type":"module","title":"Kaffy.Scheduler.Task","doc":"","ref":"Kaffy.Scheduler.Task.html"},{"type":"function","title":"Kaffy.Scheduler.Task.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Kaffy.Scheduler.Task.html#child_spec/1"},{"type":"function","title":"Kaffy.Scheduler.Task.start_link/1","doc":"","ref":"Kaffy.Scheduler.Task.html#start_link/1"},{"type":"module","title":"Kaffy.Tasks","doc":"","ref":"Kaffy.Tasks.html"},{"type":"function","title":"Kaffy.Tasks.collect_tasks/0","doc":"","ref":"Kaffy.Tasks.html#collect_tasks/0"},{"type":"function","title":"Kaffy.Tasks.tasks_info/0","doc":"","ref":"Kaffy.Tasks.html#tasks_info/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v0.10.2 (2023-10-09) - Changelog","doc":"#","ref":"changelog.html#v0-10-2-2023-10-09"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix regression introduced in v0.10.1 which made Kaffy ignore all admin modules.","ref":"changelog.html#fixes"},{"type":"extras","title":"v0.10.1 (2023-10-09) - Changelog","doc":"#","ref":"changelog.html#v0-10-1-2023-10-09"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix a crash when Kaffy mistakenly treats erlang modules as Elixir modules (PR #300)","ref":"changelog.html#fixes"},{"type":"extras","title":"v0.10.0 (2023-10-06) - Changelog","doc":"#","ref":"changelog.html#v0-10-0-2023-10-06"},{"type":"extras","title":"Fixes - Changelog","doc":"- belongs_to fields didn't respect the `:readonly` option (PR #297).","ref":"changelog.html#fixes"},{"type":"extras","title":"v0.10.0-rc.3 (2023-09-28) - Changelog","doc":"#","ref":"changelog.html#v0-10-0-rc-3-2023-09-28"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix regression when trying to save a resource with an array field.\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Added - Changelog","doc":"- Support searching fields with `id`, `integer` and `decimal` types.","ref":"changelog.html#added"},{"type":"extras","title":"v0.10.0-rc.2 (2023-09-10) - Changelog","doc":"#","ref":"changelog.html#v0-10-0-rc-2-2023-09-10"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix a crash when deleting resources from the resource page through the \"Delete\" button.","ref":"changelog.html#fixes"},{"type":"extras","title":"v0.10.0-rc.1 (2023-09-09) - Changelog","doc":"#","ref":"changelog.html#v0-10-0-rc-1-2023-09-09"},{"type":"extras","title":"Fixes - Changelog","doc":"- Crash when updating records.\n- Removes elixir and phoenix deprecation warnings [PR#288](https://github.com/aesmail/kaffy/pull/288)\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Added - Changelog","doc":"- Support for filtering `{:array, :string}` fields [PR#285](https://github.com/aesmail/kaffy/pull/262)\n- Per-context dashboard [PR#287](https://github.com/aesmail/kaffy/pull/287)\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Minimum phoenix version is now 1.6. This means that the minimum Elixir version is now 1.12 (see support policy).","ref":"changelog.html#changed"},{"type":"extras","title":"v0.10.0-rc.0 (2023-09-02) - Changelog","doc":"#","ref":"changelog.html#v0-10-0-rc-0-2023-09-02"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix changeset errors [PR#262](https://github.com/aesmail/kaffy/pull/262)\n- Preload resources before trying to convert resource to existing atom. [PR#266](https://github.com/aesmail/kaffy/pull/266)\n- Include `many_to_many` fields in `fields_to_be_removed/1`.\n- Fix array fields not being saved properly.\n- Fix `:readonly` and `:editable` options for datetime fields.\n- Default to `nil` for `belongs_to` fields.\n- Fix issue with datetime fields sometimes being updated unexpectedly.\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Changed - Changelog","doc":"- Minimum Elixir version is now 1.11.4.\n- Add `phoenix_view` package to deps.\n- Let specify the full 'path' for FontAwesome fonts [PR#186](https://github.com/aesmail/kaffy/pull/186)\n- Lazy load default kaffy field value [PR#255](https://github.com/aesmail/kaffy/pull/255)\n- Update phoenix html to address deprecated form_for [PR#260](https://github.com/aesmail/kaffy/pull/260)\n- Use left_join when building search query [PR#273](https://github.com/aesmail/kaffy/pull/273)\n- Remove the \"- Kaffy\" suffix from page titles.\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"-  Support hiding menu entries [PR#248](https://github.com/aesmail/kaffy/pull/248)\n- Add support for composite primary keys [PR#270](https://github.com/aesmail/kaffy/pull/270)\n- Index page description [PR#274](https://github.com/aesmail/kaffy/pull/274)\n- Footer can be specified in config [PR#275](https://github.com/aesmail/kaffy/pull/275)\n- Provide more flexibility for customizing the `admin_logo` and `admin_logo_mini` options.\n- Add the ability to \"bulk delete\" resources from the index page.\n- Hide save and delete buttons on the show page based on available actions.\n- Add `Kaffy.Utils.auto_detect_resources/0` which returns the list of auto-detected resources (Kaffy's attempt at discovering the list of schema/admin modules).","ref":"changelog.html#added"},{"type":"extras","title":"v0.9.4 (2022-10-31) - Changelog","doc":"#","ref":"changelog.html#v0-9-4-2022-10-31"},{"type":"extras","title":"Fixed - Changelog","doc":"- Add missing \"custom-select\" classes to some `select` tags.\n- Ensure that extension modules are loaded.\n- Save enum fields with their cast values.","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.9.3 (2022-08-13) - Changelog","doc":"#","ref":"changelog.html#v0-9-3-2022-08-13"},{"type":"extras","title":"Fixed - Changelog","doc":"- The `:readonly` option was ignored when defining `:choices` for a specific field in `form_fields` (#225)\n- Fix generating forms for embeds and enums (#234)\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Added the option to disable creating new records (#188)\n- A new `:bottom` option to display menu items at the bottom of the side menu (#237)\n- A smarter inflector covering more plural cases (#233)\n- Better documentation generation for ExDocs (#214)\n- Allow list actions to have select inputs (#238)","ref":"changelog.html#added"},{"type":"extras","title":"v0.9.2 (2022-08-03) - Changelog","doc":"#","ref":"changelog.html#v0-9-2-2022-08-03"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Display records from schemas which contain fields with names \"context\" and \"resource\".","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.9.1 (2022-07-11) - Changelog","doc":"#","ref":"changelog.html#v0-9-1-2022-07-11"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Clicking on the \"Select all\" checkbox and performing an action wasn't working properly (#129).\n- A resource with a `{:array, _}` field type used to crash when rendering the form page (#130).\n- Tidbit icons weren't shown properly.\n- Schemas with `has_many` or `many_to_many` associations crashed when trying to save if the schema doesn't have a default `changeset/2` function.\n- Support phoenix 1.6","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.9.0 (2020-07-02) - Changelog","doc":"#","ref":"changelog.html#v0-9-0-2020-07-02"},{"type":"extras","title":"Breaking change - Changelog","doc":"- If you are defining your resources manually, you need to replace all `:schemas` keys with `:resources`.\n\n#","ref":"changelog.html#breaking-change"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- `map` and JSON fields weren't being properly recognized and saved/updated (regression from v0.8.x).\n- Searching a schema which has a `:string` virtual field produced a crash.\n- \"Next\" page link was active even when there was no records to display on the next page.\n- belongs_to fields were almost invisible on small screens.\n- Schemas without a public `changeset/2` function were crashing due to parameters not being cast properly.\n- Searching a resource with a search term that contained a special SQL character (% or _) returned invalid results.\n- Multi-word contexts weren't being formatted properly.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Introducing extension modules to add custom html, css, and javascript.\n- Custom form fields for specialized functionality.\n- List actions now can have an intermediary step for more input from the user.\n- Decimal values are displayed properly on the index page.\n- Improved layout for mobile screens.\n- First column on index page is the first field in your schema.\n- Ability to override Kaffy's `insert`, `update`, and `delete` functions to customize how the function works.\n- Moved scheduled tasks to their own modules and they have their own option in config.\n- Improved alert message styles.\n- Much improved pagination UI.\n- Ability to customize the query Kaffy uses for the index and show pages.\n- A more flexible and customizable way to define resource and admin modules.\n- Added a `help_text` option to `form_fields` to display a helpful text next to the field.\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Contributors for v0.9.0 - Changelog","doc":"- Areski Belaid (@areski)\n- Axel Clark (@axelclark)\n- Adi Purnama (@adipurnama)\n- Nicolas Resnikow (@nresni)\n- Abdullah Esmail (@aesmail)","ref":"changelog.html#contributors-for-v0-9-0"},{"type":"extras","title":"v0.8.1 (2020-06-05) - Changelog","doc":"#","ref":"changelog.html#v0-8-1-2020-06-05"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- The \"Select all\" checkbox didn't work properly (thanks @areski).\n- Kaffy crashed when opening the page to select a record for the belogns_to association.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"- UI improvements on the index page (thanks @areski).\n- Replace MDI icons with FontAwesome.","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.8.0 (2020-06-03) - Changelog","doc":"#","ref":"changelog.html#v0-8-0-2020-06-03"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- removed `:permission` field option in favor of `:create` and `:update` options for more control and customization.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"New Features - Changelog","doc":"- ability to add custom links to the side menu.\n- ability to add add custom pages.\n- ability to order records per column in the index page.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Enhancements - Changelog","doc":"- a placeholder value for :map textarea fields to indicate that JSON content is expected.\n- enhanced \"humanization\" of field names in index page.\n- improved checkbox form control UI (thanks @areski).\n- new and improved design (thanks @areski).\n- include checkboxes in index page to clearly indicate records are selectable.\n- pagination, filtration, and searching are now bookmarkable with querystring parameters.\n- `count` query result is now cached if the table has more than 100,000 records (thanks @areski).\n- add option to hide the dashboard menu item.\n- add option to change the root url to be something other than the dashboard.\n- removed render warnings when running under phoenix 1.5.\n- add a much improved date/time picker (thanks @areski).","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.7.1 (2020-05-23) - Changelog","doc":"#","ref":"changelog.html#v0-7-1-2020-05-23"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- kaffy was ignoring the default/custom changeset functions when creating/updating records.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"- do not show the \"Tasks\" menu item if there are no tasks (thanks @areski).\n- esthetic changes on the index page (thanks @areski).","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.7.0 (2020-05-22) - Changelog","doc":"#","ref":"changelog.html#v0-7-0-2020-05-22"},{"type":"extras","title":"New Features - Changelog","doc":"- introducing simple scheduled tasks.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Enhancements - Changelog","doc":"- search across associations.\n- improve how autodetected schema names are formatted.\n- clicking on the upper left title goes to the website's root \"/\" (used to go to the dashboard page, which already has a link in the menu).\n- fix a few typos in README (thanks @areski).","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.6.2 (2020-05-20) - Changelog","doc":"#","ref":"changelog.html#v0-6-2-2020-05-20"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- multi-word CamelCase schemas weren't being saved properly.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"- by default, do not include autogenerated fields resource form page.\n- order autodetected contexts/schemas alphabetically.","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.6.1 (2020-05-19) - Changelog","doc":"#","ref":"changelog.html#v0-6-1-2020-05-19"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- sometimes the primary key field (id) is treated as an association.\n- the popup for selecting a \"belongs_to\" record was not displaying any records.\n- use `fn/0` instead of `fn/1` with `Ecto.Repo.transaction/2` to support ecto 2.x.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.6.0 (2020-05-18) - Changelog","doc":"#","ref":"changelog.html#v0-6-0-2020-05-18"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- always include the `:kaffy_browser` pipeline to display templates correctly. Please check the minimum configurations - section in the README for more information on how to upgrade.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"New Features - Changelog","doc":"- support custom actions for a group of selected resources in index page.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- resource index page table was displayed incorrectly when using a custom pipeline.\n- all side menu resources are shown by default including sections that are not currently active.\n- side menu does not scroll when there are too many contexts/schemas.\n- side menu items all popup at the same time when viewed on small screens.\n\n#","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Misc - Changelog","doc":"- added a demo link to the hex package page.","ref":"changelog.html#misc"},{"type":"extras","title":"v0.5.1 (2020-05-17) - Changelog","doc":"#","ref":"changelog.html#v0-5-1-2020-05-17"},{"type":"extras","title":"Enhancements - Changelog","doc":"- add a rich text editor option for form fields (`type: :richtext`).\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- dashboard widgets were displayed improperly on small screens.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.5.0 (2020-05-16) - Changelog","doc":"###","ref":"changelog.html#v0-5-0-2020-05-16"},{"type":"extras","title":"compatible with v0.4.x - Changelog","doc":"#","ref":"changelog.html#compatible-with-v0-4-x"},{"type":"extras","title":"New Features - Changelog","doc":"- introducing custom widgets in the dashboard.","ref":"changelog.html#new-features"},{"type":"extras","title":"v0.4.1 (2020-05-14) - Changelog","doc":"#","ref":"changelog.html#v0-4-1-2020-05-14"},{"type":"extras","title":"New Features - Changelog","doc":"- add custom field filters.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- sometimes if `index/1` is not defined in the admin module, the index page is empty.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.4.0 (2020-05-13) - Changelog","doc":"#","ref":"changelog.html#v0-4-0-2020-05-13"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- pass `conn` struct to all callback functions.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"New Features - Changelog","doc":"- introducing custom actions for single resources.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Enhancements - Changelog","doc":"- fix typo in the resource form (thanks @axelclark).","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.3.2 (2020-05-12) - Changelog","doc":"#","ref":"changelog.html#v0-3-2-2020-05-12"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Kaffy didn't compile with elixir < 1.10 due to the use of `Kernel.is_struct`. It is currently tested with elixir 1.7+\n- Sometimes new records couldn't be created if they have `:map` fields.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.3.1 (2020-05-12) - Changelog","doc":"#","ref":"changelog.html#v0-3-1-2020-05-12"},{"type":"extras","title":"Enhancements - Changelog","doc":"- A better way to support foreign key fields with a huge amount of records to select from.\n- Retrieve the actual name of the association field from the association struct.","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.3.0 (2020-05-11) - Changelog","doc":"#","ref":"changelog.html#v0-3-0-2020-05-11"},{"type":"extras","title":"New Features - Changelog","doc":"- Added ability to delete resources.\n- Added resource callbacks when creating, updating, and deleting resources.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Don't try to decode map fields when they are empty.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.2.1 (2020-05-10) - Changelog","doc":"#","ref":"changelog.html#v0-2-1-2020-05-10"},{"type":"extras","title":"New Features - Changelog","doc":"- Added support for embedded schemas.\n- Added support for `:map` fields for json values.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Use the json library configured for phoenix instead of hardcoding `Jason`.\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Don't crash when the schema has a `has_many` or `has_one` association.\n- Don't crash when the schema has a map field or an embedded schema.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.2.0 (2020-05-09) - Changelog","doc":"#","ref":"changelog.html#v0-2-0-2020-05-09"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- The `:otp_app` config is now required.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"New Features - Changelog","doc":"- Kaffy will now auto-detect your schemas and admin modules if they're not set explicitly. See the README file for more.\n\n#","ref":"changelog.html#new-features"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Kaffy now supports phoenix 1.4 and higher.\n- Removed some deprecation warnings when compiling kaffy\n- Massively simplified configurations. The only required configs now are `otp_app`, `ecto_repo`, and `router`.","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.1.2 (2020-05-08) - Changelog","doc":"#","ref":"changelog.html#v0-1-2-2020-05-08"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Much improved UI.\n- Some code cleanups.","ref":"changelog.html#enhancements"},{"type":"extras","title":"v0.1.1 (2020-05-07) - Changelog","doc":"#","ref":"changelog.html#v0-1-1-2020-05-07"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Removed the dependency on `:jason`.\n\n#","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"- Changed `plug :fetch_live_flash` to `plug :fetch_flash` for the default pipeline.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"License","doc":"# The MIT License\n\nCopyright (c) 2020 Abdullah Esmail\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Kaffy\n\n[![Module Version](https://img.shields.io/hexpm/v/kaffy.svg)](https://hex.pm/packages/kaffy)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/kaffy/)\n[![Total Download](https://img.shields.io/hexpm/dt/kaffy.svg)](https://hex.pm/packages/kaffy)\n[![License](https://img.shields.io/hexpm/l/kaffy.svg)](https://github.com/aesmail/kaffy/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/aesmail/kaffy.svg)](https://github.com/aesmail/kaffy/commits/master)\n\n![What You Get](assets/kaffy_index.png)","ref":"readme.html"},{"type":"extras","title":"Introduction - Overview","doc":"Kaffy was created out of a need to have a powerfully simple, flexible, and customizable admin interface\nwithout the need to touch the current codebase. It was inspired by django's lovely built-in `admin` app and rails' powerful `activeadmin` gem.","ref":"readme.html#introduction"},{"type":"extras","title":"Sections - Overview","doc":"- [Introduction](#introduction)\n- [Sections](#sections)\n- [Sponsors](#sponsors)\n- [Demo](#demo)\n- [Minimum Requirements](#minimum-requirements)\n- [Installation](#installation)\n    - [Add `kaffy` as a dependency](#add-kaffy-as-a-dependency)\n    - [These are the minimum configurations required](#these-are-the-minimum-configurations-required)\n- [Customizations](#customizations)\n  - [Configurations](#configurations)\n    - [Breaking change in v0.9](#breaking-change-in-v09)\n  - [Dashboard page](#dashboard-page)\n  - [Side Menu](#side-menu)\n    - [Custom Links](#custom-links)\n  - [Custom Pages](#custom-pages)\n  - [Index pages](#index-pages)\n  - [Form Pages](#form-pages)\n    - [Association Forms](#association-forms)\n  - [Custom Form Fields](#custom-form-fields)\n  - [Customize the Queries](#customize-the-queries)\n  - [Extensions](#extensions)\n  - [Embedded Schemas and JSON Fields](#embedded-schemas-and-json-fields)\n  - [Search](#search)\n  - [Authorization](#authorization)\n  - [Changesets](#changesets)\n  - [Singular vs Plural](#singular-vs-plural)\n  - [Custom Actions](#custom-actions)\n    - [Single Resource Actions](#single-resource-actions)\n    - [List Actions](#list-actions)\n  - [Callbacks](#callbacks)\n  - [Overwrite actions](#overwrite-actions)\n  - [Scheduled Tasks](#scheduled-tasks)\n- [The Driving Points](#the-driving-points)","ref":"readme.html#sections"},{"type":"extras","title":"Sponsors - Overview","doc":"Sponsor the [development of Kaffy](https://github.com/sponsors/aesmail) through GitHub Sponsors.","ref":"readme.html#sponsors"},{"type":"extras","title":"Demo - Overview","doc":"[Check out the simple demo here](https://kaffy.fly.dev/admin/)","ref":"readme.html#demo"},{"type":"extras","title":"Minimum Requirements - Overview","doc":"Starting with v0.10.0, Kaffy will officially support the latest two phoenix versions.\n\n| Kaffy   | Supported phoenix versions |\n|---------|----------------------------|\n| v0.10.0 | 1.6, 1.7.0                 |\n| v0.9.X  | 1.5, 1.6, 1.7.0            |\n|         |                            |","ref":"readme.html#minimum-requirements"},{"type":"extras","title":"Support Policy - Overview","doc":"The latest released `major.minor` version will be supported. For example, if the latest version is `0.9.0`, then `0.9.1` will be released with bug fixes. If a new version `0.10.0` is released, then `0.9.1` will no longer receive bug fixes or security patches.","ref":"readme.html#support-policy"},{"type":"extras","title":"Installation - Overview","doc":"##","ref":"readme.html#installation"},{"type":"extras","title":"Add `:kaffy` as a dependency - Overview","doc":"```elixir\ndef deps do\n  [\n    {:kaffy, \"~> 0.10.0\"}\n  ]\nend\n```\n\nIf you are using `kaffy` v0.9.x with `phoenix` 1.7, you need to add `phoenix_view` to your dependencies:\n```elixir\ndef deps do\n  [\n    {:phoenix_view, \"~> 2.0.2\"},\n    {:kaffy, \"~> 0.9.4\"}\n  ]\nend\n```\n\n##","ref":"readme.html#add-kaffy-as-a-dependency"},{"type":"extras","title":"These are the minimum configurations required - Overview","doc":"```elixir\n# in your router.ex\nuse Kaffy.Routes, scope: \"/admin\", pipe_through: [:some_plug, :authenticate]\n# :scope defaults to \"/admin\"\n# :pipe_through defaults to kaffy's [:kaffy_browser]\n# when providing pipelines, they will be added after :kaffy_browser\n# so the actual pipe_through for the previous line is:\n# [:kaffy_browser, :some_plug, :authenticate]\n\n# in your endpoint.ex\n# configure the path to your application static assets in :at\n# the path must end with `/kaffy`\nplug Plug.Static,\n  at: \"/kaffy\", # or \"/path/to/your/static/kaffy\"\n  from: :kaffy,\n  gzip: false,\n  only: ~w(assets)\n\n# in your config/config.exs\nconfig :kaffy,\n  # required keys\n  otp_app: :my_app, # required\n  ecto_repo: MyApp.Repo, # required\n  router: MyAppWeb.Router, # required\n  # optional keys\n  admin_title: \"My Awesome App\",\n  admin_logo: [\n    url: \"https://example.com/img/logo.png\",\n    style: \"width:200px;height:66px;\"\n  ],\n  admin_logo_mini: \"/images/logo-mini.png\",\n  hide_dashboard: true,\n  home_page: [schema: [:accounts, :user]],\n  enable_context_dashboards: true, # since v0.10.0\n  admin_footer: \"Kaffy &copy; 2023\" # since v0.10.0\n```\n\nNote that providing pipelines with the `:pipe_through` option will add those pipelines to kaffy's `:kaffy_browser` pipeline which is defined as follows:\n\n```elixir\npipeline :kaffy_browser do\n  plug :accepts, [\"html\", \"json\"]\n  plug :fetch_session\n  plug :fetch_flash\n  plug :protect_from_forgery\n  plug :put_secure_browser_headers\nend\n```\n#","ref":"readme.html#these-are-the-minimum-configurations-required"},{"type":"extras","title":"Phoenix version 1.7 - Overview","doc":"Note that if you use Phoenix version 1.7 you also need to manually add the use of phoenix views in your project.\nFollow the instructions at https://hexdocs.pm/phoenix_view/Phoenix.View.html\n\nYou will also need to change `helpers: false` to `true` in the `myapp_web.ex` file as shown in example below.\n```elixir\n  # lib/myapp_web.ex\n  def router do\n    quote do\n      use Phoenix.Router, helpers: true # <- set to true\n```","ref":"readme.html#phoenix-version-1-7"},{"type":"extras","title":"Customizations - Overview","doc":"#","ref":"readme.html#customizations"},{"type":"extras","title":"Configurations - Overview","doc":"##","ref":"readme.html#configurations"},{"type":"extras","title":"Breaking change in v0.9 - Overview","doc":"If you're upgrading from an earlier version to v0.9, you need to replace your `:schemas` with `:resources`.\n\nIf you don't specify a `resources` option in your configs, Kaffy will try to auto-detect your schemas and your admin modules. Admin modules should be in the same namespace as their respective schemas in order for kaffy to detect them. For example, if you have a schema `MyApp.Products.Product`, its admin module should be `MyApp.Products.ProductAdmin`.\n\nOtherwise, if you'd like to explicitly specify your schemas and their admin modules, you can do like the following:\n\n```elixir\n# config.exs\nconfig :kaffy,\n  admin_title: \"My Awesome App\",\n  admin_logo: \"/images/logo.png\",\n  admin_logo_mini: \"/images/logo-mini.png\",\n  admin_footer: \"Kaffy &copy; 2023\",\n  hide_dashboard: false,\n  enable_context_dashboards: true,\n  home_page: [kaffy: :dashboard],\n  ecto_repo: MyApp.Repo,\n  router: MyAppWeb.Router,\n  resources: &MyApp.Kaffy.Config.create_resources/1\n\n# in your custom resources function\ndefmodule MyApp.Kaffy.Config do\n  def create_resources(_conn) do\n    [\n      blog: [\n        name: \"My Blog\", # a custom name for this context/section.\n        resources: [ # this line used to be \"schemas\" in pre v0.9\n          post: [schema: MyApp.Blog.Post, admin: MyApp.SomeModule.Anywhere.PostAdmin],\n          comment: [schema: MyApp.Blog.Comment],\n          tag: [schema: MyApp.Blog.Tag, in_menu: false]\n        ]\n      ],\n      inventory: [\n        name: \"Inventory\",\n        resources: [\n          category: [schema: MyApp.Products.Category, admin: MyApp.Products.CategoryAdmin],\n          product: [schema: MyApp.Products.Product, admin: MyApp.Products.ProductAdmin]\n        ]\n      ]\n    ]\n  end\nend\n```\n\nStarting with Kaffy v0.9, the `:resources` option can take a literal list or a function.\nIf a function is provided, it should take a conn and return a list of contexts and schemas like in the example above.\nPassing a conn to the function provides more flexibility and customization to your resources list.\n\nYou can set the `:hide_dashboard` option to true to hide the dashboard link from the side menu.\nTo change the home page, change the `:home_page` option to one of the following:\n\n- `[kaffy: :dashboard]` for the default dashboard page.\n- `[schema: [\"blog\", \"post\"]]` to make the home page the index page for the `Post` schema under the 'Blog' context.\n- `[page: \"my-custom-page\"]` to make the custom page with the `:slug` \"my-custom-page\" the home page. See the Custom Pages section below.\n\nNote that, for auto-detection to work properly, schemas in different contexts should have different direct \"prefix\" namespaces. That is:\n\n```elixir\n# auto-detection works properly with this:\nMyApp.Posts.Post\nMyApp.Posts.Category\nMyApp.Products.Product\nMyApp.Products.Category # this Category will not be confused with Posts.Category\n\n# auto-detection will be confused with this:\n# both Category schemas have the same \"Schemas\" prefix.\nMyApp.Posts.Schemas.Post\nMyApp.Posts.Schemas.Category\nMyApp.Products.Schemas.Product\nMyApp.Products.Schemas.Category\n\n# To fix this, define resources manually:\nresources: [\n  posts: [\n    resources: [\n      post: [schema: MyApp.Posts.Schemas.Post],\n      category: [schema: MyApp.Posts.Schemas.Category]\n    ]\n  ],\n  products: [\n    resources: [\n      product: [schema: MyApp.Products.Schemas.Product],\n      category: [schema: MyApp.Products.Schemas.Category]\n    ]\n  ]\n]\n```\n\n#","ref":"readme.html#breaking-change-in-v0-9"},{"type":"extras","title":"Dashboard page - Overview","doc":"Kaffy supports dashboard customizations through `widgets`.\n\n![Dashboard page widgets](assets/kaffy_dashboard.png)\n\nCurrently, kaffy provides support for 4 types of widgets:\n\n- `text` widgets. Suitable for display relatively long textual information. Candidates: a short review, a specific message for the admin, etc.\n- `tidbit` widgets. Suitable for tiny bits of information (one word, or one number). Cadidates: total sales, a specific date, system status (\"Healthy\", \"Down\"), etc.\n- `progress` widgets. Suitable for measuring progress in terms of percentages. Candidates: task progress, survey results, memory usage, etc.\n- `chart` widgets. Suitable for displaying chart data with X and Y values. Candidates: any measurable number over a period of time (e.g. sales, visits, etc).\n\nWidgets have shared options:\n\n- `:type` (required) is the type of the widget. Valid options are `text`, `tidbit`, `progress`, and `chart`.\n- `:title` (required) is the title for the widget. What this widget is about.\n- `:content` (required) is the main content of the widget. This can be a string or a map depending on the type of widget.\n- `:order` (optional) is the displaying order of the widget. Widgets are display in order based on this value. The default value is 999.\n- `:width` (optional) is the width the widget should occupy on the page. Valid values are 1 to 12. The default for tidbits is 3 and the others 6.\n- `:percentage` (required for progress widgets) is the percentage value for the progress. This must be an integer.\n- `:full_icon` (optional for tidbit widgets) is the icon displayed next to the tidbit's `content`. You have to specify the full name given by FontAwesome like `fas fa-thumbs-up`.\n- `:icon` (optional for tidbit widgets) is the icon displayed next to the tidbit's `content`. Any FontAwesome-valid icon is valid here. For example: `thumbs-up`. But it's limited to the `fas` group. For full defintion see `:full_icon`.\n\nWhen defining a chart widget, the content must be a map with the following required keys:\n\n- `:x` must be a list of values for the x-axis.\n- `:y` must be a list of numbers (integers/floats) for the y-axis.\n- `:y_title` must be a string describing `:y` (e.g. USD, Transactions, Visits, etc)\n\n\nTo create widgets, define `widgets/2` in your admin modules.\n\n`widgets/2` takes a schema and a `conn` and must return a list of widget maps:\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def widgets(_schema, _conn) do\n    [\n      %{\n        type: \"tidbit\",\n        title: \"Average Reviews\",\n        content: \"4.7 / 5.0\",\n        icon: \"thumbs-up\",\n        order: 1,\n        width: 6,\n      },\n      %{\n        type: \"progress\",\n        title: \"Pancakes\",\n        content: \"Customer Satisfaction\",\n        percentage: 79,\n        order: 3,\n        width: 6,\n      },\n      %{\n        type: \"chart\",\n        title: \"This week's sales\",\n        order: 8,\n        width: 12,\n        content: %{\n          x: [\"Mon\", \"Tue\", \"Wed\", \"Thu\", \"Today\"],\n          y: [150, 230, 75, 240, 290],\n          y_title: \"USD\"\n        }\n      }\n    ]\n  end\nend\n```\n\nKaffy will collect all widgets from all admin modules and orders them based on the `:order` option if present and displays them on the dashboard page.\n\n#","ref":"readme.html#dashboard-page"},{"type":"extras","title":"Side Menu - Overview","doc":"##","ref":"readme.html#side-menu"},{"type":"extras","title":"Custom Links - Overview","doc":"Kaffy provides support for adding custom links to the side navigation menu.\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def custom_links(_schema) do\n    [\n      %{name: \"Source Code\", url: \"https://example.com/repo/issues\", order: 2, location: :top, icon: \"paperclip\"},\n      %{name: \"Products On Site\", url: \"https://example.com/products\", location: :sub, target: \"_blank\"},\n      %{name: \"Support us\", url: \"https://example.com/products\", location: :bottom, target: \"_blank\",  icon: \"usd\"},\n    ]\n  end\nend\n```\n\n`custom_links/1` takes a schema and should return a list of maps with the following keys:\n\n- `:name` to display as the text for the link.\n- `:url` to contain the actual URL.\n- `:method` the method to use with the link.\n- `:order` to hold the displayed order of this link. All `:sub` links are ordered under the schema menu item directly before the following schema.\n- `:location` can be either `:sub`, `:top` or `:bottom`. `:sub` means it's under the schema sub-item. `:top` means it's displayed at the top of the menu below the \"Dashboard\" link. `:bottom` means it's displayed at the bottom of the menu below the last context menu item. Links are ordered based on the `:order` value. The default value is `:sub`.\n- `:icon` is the icon displayed next to the link. Any FontAwesome-valid icon is valid here. For example: `paperclip`.\n- `:target` to contain the target to open the link: `_blank` or `_self`. `_blank` will open the link in a new window/tab, `_self` will open the link in the same window. The default value is `_self`.\n\n\n#","ref":"readme.html#custom-links"},{"type":"extras","title":"Custom Pages - Overview","doc":"Kaffy allows you to add custom pages like the following:\n\n![Custom Pages](assets/kaffy_custom_pages.png)\n\nTo add custom pages, you need to define the `custom_pages/2` function in your admin module:\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def custom_pages(_schema, _conn) do\n    [\n      %{\n        slug: \"my-own-thing\",\n        name: \"Secret Place\",\n        view: MyAppWeb.ProductView,\n        template: \"custom_product.html\",\n        assigns: [custom_message: \"one two three\"],\n        order: 2\n      }\n    ]\n  end\nend\n```\n\nThe `custom_pages/2` function takes a schema and a conn and must return a list of maps corresponding to pages.\nThe maps have the following keys:\n\n- `:slug` to indicate the url of the page, e.g., `/admin/p/my-own-thing`.\n- `:name` for the name of the link on the side menu.\n- `:view` to set the view from your own app.\n- `:template` to set the custom template you want to render in Kaffy's layout.\n- `:assigns` (optional) to hold the assigns for the template. Default to an empty list.\n- `:order` is the order of the page among other pages in the side menu.\n\n#","ref":"readme.html#custom-pages"},{"type":"extras","title":"Index pages - Overview","doc":"The `index/1` function takes a schema and must return a keyword list of fields and their options.\n\nIf the options are `nil`, Kaffy will use default values for that field.\n\nIf this function is not defined, Kaffy will return all fields with their respective values.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n\n  def popular?(p) do\n    if (p.popular), do: \"✅\", else: \"❌\"\n  end\n\n  def index(_) do\n    [\n      title: nil,\n      views: %{name: \"Hits\"},\n      date: %{name: \"Date Added\", value: fn p -> p.inserted_at end},\n      popular: %{name: \"Popular?\", value: fn p -> popular?(p) end},\n    ]\n  end\nend\n```\n\nResult\n\n![Customized index page](assets/kaffy_index.png)\n\nNotice that the keyword list keys don't necessarily have to be schema fields as long as you provide a `:value` option.\n\nYou can also provide some basic column-based filtration by providing the `:filters` option:\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def index(_) do\n    [\n      title: nil,\n      category_id: %{\n        value: fn p -> get_category!(p.category_id).name end,\n        filters: Enum.map(list_categories(), fn c -> {c.name, c.id} end)\n      },\n      price: %{value: fn p -> Decimal.to_string(p.price) end},\n      quantity: nil,\n      status: %{\n        name: \"Is it available?\",\n        value: fn p -> available?(p) end,\n        filters: [{\"Available\", \"available\"}, {\"Sold out\", \"soldout\"}]\n      },\n      views: nil\n    ]\n  end\nend\n```\n\n`:filters` must be a list of tuples where the first element is a human-frieldy string and the second element is the actual field value used to filter the records.\n\nResult\n\n![Product filters](assets/kaffy_filters.png)\n\nIf you need to change the order of the records, define `ordering/1`:\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def ordering(_schema) do\n    # order posts based on views\n    [desc: :views]\n  end\nend\n```\n\nIf you need to hide the \"New  \" button, you can define the `default_actions/1` function in your admin module:\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def default_actions(_schema) do\n    # default actions are [:new, :edit, :delete] by default.\n    [:delete] # cannot create or edit posts, can only delete.\n  end\nend\n```\n\n#","ref":"readme.html#index-pages"},{"type":"extras","title":"Form Pages - Overview","doc":"Kaffy treats the show and edit pages as one, the form page.\n\nTo customize the fields shown in this page, define a `form_fields/1` function in your admin module.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def form_fields(_) do\n    [\n      title: nil,\n      status: %{choices: [{\"Publish\", \"publish\"}, {\"Pending\", \"pending\"}]},\n      body: %{type: :textarea, rows: 4},\n      views: %{create: :hidden, update: :readonly},\n      settings: %{label: \"Post Settings\"},\n      slug: %{help_text: \"Define your own slug for the post, if empty one will be created for you using the post title.\"}\n    ]\n  end\nend\n```\n\nThe `form_fields/1` function takes a schema and should return a keyword list of fields and their options.\n\nThe keys of the list must correspond to the schema fields.\n\nOptions can be:\n\n- `:label` - must be a string.\n- `:type` - can be any ecto type in addition to `:file`, `:textarea`, and `:richtext`.\n- `:rows` - an integer to indicate the number of rows for textarea fields.\n- `:choices` - a keyword list of option and values to restrict the input values that this field can accept.\n- `:create` - can be `:editable` which means it can be edited when creating a new record, or `:readonly` which means this field is visible when creating a new record but cannot be edited, or `:hidden` which means this field shouldn't be visible when creating a new record. It is `:editable` by default.\n- `:update` - can be `:editable` which means it can be edited when updating an existing record, or `:readonly` which means this field is visible when updating a record but cannot be edited, or `:hidden` which means this field shouldn't be visible when updating record. It is `:editable` by default.\n- `:help_text` - extra \"help text\" to be displayed with the form field.\n- `:values_fn` - This allows passing in a function to populate the list of possible values for a `:array` field. The field will be rendered as a multi-select input. The function should be of arity 2 and the arguments are the entity and the conn. See example below\n\nResult\n\n![Customized show/edit page](assets/kaffy_form.png)\n\nNotice that:\n\n- Even though the `status` field is of type `:string`, it is rendered as a ` ` element with choices.\n- The `views` field is rendered as \"readonly\" because it was set as `:readonly` for the update form.\n- `settings` is an embedded schema. That's why it is rendered as such.\n\n\nSetting a field's type to `:richtext` will render a rich text editor.\n\nThe `:values_fn` is passed the entity you are editing and the conn (in that order) and must return a list of tuples that represent the {name, value} to use in the multi select. An example of this is as follows:\n\n```elixir\ndef form_fields(_schema) do\n  [\n    ....\n    some_array_field: %{\n      values_fn: fn entity, conn ->\n        some_values = MyApp.Thing.fetch_values(entity.id, conn)\n        Enum.map(some_values, &{&1.name, &1.id})\n      end\n    }\n  ]\nend\n```\n\nIf you don't want users to be able to edit or delete records, you can define the `default_actions/1` function in your admin module:\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def default_actions(_schema) do\n    # default actions are [:new, :edit, :delete] by default.\n    [:new] # only create records, cannot edit or delete.\n  end\nend\n```\n\n##","ref":"readme.html#form-pages"},{"type":"extras","title":"Association Forms - Overview","doc":"A `belongs_to` association should be referenced by the field name, *not* the association name. For example, a schema with the following association:\n\n\n```elixir\nschema \"my_model\" do\n  ...\n  belongs_to :owner, App.Owners.Owner\n  ...\nend\n```\n\nWould define `form_fields/1` like so:\n\n```elixir\ndef form_fields(_) do\n  [\n    ...\n    owner_id: nil,\n    ...\n  ]\nend\n```\n\n**NOTE:** `many_to_many` associations are currently not supported.\n\n#","ref":"readme.html#association-forms"},{"type":"extras","title":"Custom Form Fields - Overview","doc":"You can create your own form fields very easily with Kaffy.\nJust follow the instructions on how to create a custom type for ecto and add 2 additional functions to the module:\n`render_form/5` and `render_index/3`.\nCheck the below example or a better example on the comments of [this issue](https://github.com/aesmail/kaffy/issues/54).\n\n```elixir\ndefmodule MyApp.Kaffy.URLField do\n  use Ecto.Type\n  def type, do: :string\n\n  # casting input from the form and making it \"storable\" inside the database column (:string)\n  def cast(url) when is_map(url) do\n    name = Map.get(url, \"one\")\n    link = Map.get(url, \"two\")\n    {:ok, ~s( #{name} )}\n  end\n\n  # if the input is not a string, return an error\n  def cast(_), do: :error\n\n  # loading the raw value from the database and turning it into a expected data type for the form\n  def load(data) when is_binary(data) do\n    [[_, link]] = Regex.scan(~r/href=\"(.*)\"/, data)\n    [[_, name]] = Regex.scan(~r/>(.*) )},\n      Phoenix.HTML.Form.label(form, field, \"Web URL\"),\n      Phoenix.HTML.Form.text_input(form, field,\n        placeholder: \"This is a custom field\",\n        class: \"form-control\",\n        name: \"#{form.name}[#{field}][one]\",\n        id: \"#{form.name}_#{field}_one\",\n        value: get_field_value(changeset, field, \"one\")\n      ),\n      Phoenix.HTML.Form.text_input(form, field,\n        placeholder: \"This is a custom field\",\n        class: \"form-control\",\n        name: \"#{form.name}[#{field}][two]\",\n        id: \"#{form.name}_#{field}_two\",\n        value: get_field_value(changeset, field, \"two\")\n      ),\n      {:safe, ~s( )}\n    ]\n  end\n\n  # this is how the field should be rendered on the index page\n  def render_index(resource, field, _options) do\n    case Map.get(resource, field) do\n      nil ->\n        \"\"\n\n      details ->\n        name = details[\"one\"]\n        link = details[\"two\"]\n        {:safe, ~s( #{name} )}\n    end\n  end\n\n  defp get_field_value(changeset, field, subfield) do\n    field_value = Map.get(changeset.data, field)\n    Map.get(field_value || %{}, subfield, \"\")\n  end\nend\n```\n\n\n#","ref":"readme.html#custom-form-fields"},{"type":"extras","title":"Customize the Queries - Overview","doc":"By default Kaffy does a simple Ecto query to retrieve records.  You can customize the queries used by Kaffy by using `custom_index_query` and `custom_show_query`.  This allows you to preload associations to display associated data on your pages, for example.  Attempting to access an association without preloading it first will result in a `Ecto.Association.NotLoaded` exception.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def custom_index_query(_conn, _schema, query) do\n    from(r in query, preload: [:tags])\n  end\n\n  def custom_show_query(_conn, _schema, query) do\n    case user_is_admin?(conn) do\n      true -> from(r in query, preload: [:history])\n      false -> query\n    end\n  end\nend\n```\n\nThe `custom_index_query/3` function takes a conn, the schema, and the query to customize, and it must return a query.\nIt is called when fetching the resources for the index page.\n\nThe `custom_show_query/3` is identifical to `custom_index_query/3`, but works when fetching a single resource in the show/edit page.\n\nIt's also possible to pass `opts` to the Repo operation, in this case, you just have to return a tuple instead, like below:\n\n```elixir\ndefmodule MyApp.Accounts.TenantAdmin do\n  def custom_index_query(_conn, _schema, query) do\n    {query, skip_tenant_id: true}\n  end\n\n  def custom_show_query(_conn, _schema, query) do\n    {query, skip_tenant_id: true}\n  end\nend\n```\n\n#","ref":"readme.html#customize-the-queries"},{"type":"extras","title":"Extensions - Overview","doc":"Extensions allow you to define custom CSS, JavaScript, and HTML.\nFor example, you need to use a specific JavaScript library or customize the look and feel of Kaffy.\nThis is where extensions come in handy.\n\nExtensions are elixir modules which special functions.\n\n```elixir\ndefmodule MyApp.Kaffy.Extension do\n  def stylesheets(_conn) do\n    [\n      {:safe, ~s( )}\n    ]\n  end\n\n  def javascripts(_conn) do\n    [\n      {:safe, ~s(  )}\n    ]\n  end\nend\n```\n\nThere are currently 2 special functions supported in extensions: `stylesheets/1` and `javascripts/1`.\nBoth functions take a conn and must return a list of safe strings.\n`stylesheets/1` will add whatever you include at the end of the ` ` tag.\n`javascripts/1` will add whatever you include there just before the closing ` ` tag.\n\nOnce you have your extension module, you need to add it to the `extensions` list in config:\n\n```elixir\nconfig :kaffy,\n  # other settings\n  extensions: [\n    MyApp.Kaffy.Extension\n  ]\n```\n\nYou can check [this issue](https://github.com/aesmail/kaffy/issues/54) to see an example which uses extensions with custom fields.\n\n#","ref":"readme.html#extensions"},{"type":"extras","title":"Embedded Schemas and JSON Fields - Overview","doc":"Kaffy has support for Ecto's [embedded schemas](https://hexdocs.pm/ecto/Ecto.Schema.html#embedded_schema/1) and JSON fields. When you define a field as a `:map`, Kaffy will automatically display a textarea with a placeholder to hint that JSON content is expected. When you have an embedded schema, Kaffy will try to render each field inline with the form of the parent schema.\n\n#","ref":"readme.html#embedded-schemas-and-json-fields"},{"type":"extras","title":"Search - Overview","doc":"Kaffy provides very basic search capabilities.\n\nSupported field types are: `:string`, `:textarea`, `:richtext`, `:id`, `:integer`, and `:decimal`.\n\nIf you need to customize the list of fields to search against, define the `search_fields/1` function.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def search_fields(_schema) do\n    [:id, :title, :body, :views]\n  end\nend\n```\n\nKaffy allows to search for fields across associations. The following tells Kaffy to search posts by title and body and category's name and description:\n\n```elixir\n# Post has a belongs_to :category association\ndefmodule MyApp.Blog.PostAdmin do\n  def search_fields(_schema) do\n    [\n      :title,\n      :body,\n      :view,\n      category: [:name, :description]\n    ]\n  end\nend\n```\n\nThis function takes a schema and returns a list of schema fields that you want to search.\n\nIf this function is not defined, Kaffy will return all fields with supported types by default.\n\n#","ref":"readme.html#search"},{"type":"extras","title":"Authorization - Overview","doc":"Kaffy supports basic authorization for individual schemas by defining `authorized?/2`.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def authorized?(_schema, conn) do\n    MyApp.Blog.can_see_posts?(conn.assigns.user)\n  end\nend\n```\n\n`authorized?/2` takes a schema and a `Plug.Conn` struct and should return a boolean value.\n\nIf it returns `false`, the request is redirected to the dashboard with an unauthorized message.\n\nNote that the resource is also removed from the resources list if `authorized?/2` returns false.\n\n#","ref":"readme.html#authorization"},{"type":"extras","title":"Changesets - Overview","doc":"Kaffy supports separate changesets for creating and updating schemas.\n\nJust define `create_changeset/2` and `update_changeset/2`.\n\nBoth of them are passed the schema and the attributes.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def create_changeset(schema, attrs) do\n    # do whatever you want, must return a changeset\n    MyApp.Blog.Post.my_customized_changeset(schema, attrs)\n  end\n\n  def update_changeset(entry, attrs) do\n    # do whatever you want, must return a changeset\n    MyApp.Blog.Post.update_changeset(entry, attrs)\n  end\nend\n```\n\nIf either function is not defined, Kaffy will try calling `Post.changeset/2`.\n\nAnd if that is not defined, `Ecto.Changeset.change/2` will be called.\n\n#","ref":"readme.html#changesets"},{"type":"extras","title":"Singular vs Plural - Overview","doc":"Kaffy makes some effor to guess a correct plural form of the resource, but in some cases it will fail. Should this happen, you may want to set a correct name yourself.\n\nThis is why `singular_name/1` and `plural_name/1` are there.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def singular_name(_) do\n    \"Article\"\n  end\n\n  def plural_name(_) do\n    \"Terms\"\n  end\nend\n```\n\n#","ref":"readme.html#singular-vs-plural"},{"type":"extras","title":"Custom Actions - Overview","doc":"##","ref":"readme.html#custom-actions"},{"type":"extras","title":"Single Resource Actions - Overview","doc":"Kaffy supports performing custom actions on single resources by defining the `resource_actions/1` function.\n\n```elixir\ndefmodule MyApp.Blog.ProductAdmin\n  def resource_actions(_conn) do\n    [\n      publish: %{name: \"Publish this product\", action: fn _c, p -> restock(p) end},\n      soldout: %{name: \"Sold out!\", action: fn _c, p -> soldout(p) end}\n    ]\n  end\n\n  defp restock(product) do\n    update_product(product, %{\"status\" => \"available\"})\n  end\n\n  defp soldout(product) do\n    case product.id == 3 do\n      true ->\n        {:error, product, \"This product should never be sold out!\"}\n\n      false ->\n        update_product(product, %{\"status\" => \"soldout\"})\n    end\n  end\n```\n\nResult\n\n![Single actions](assets/kaffy_resource_actions.png)\n\n`resource_actions/1` takes a `conn` and must return a keyword list.\nThe keys must be atoms defining the unique action \"keys\".\nThe values are maps providing a human-friendly `:name` and an `:action` that is an anonymous function with arity 2 that takes a `conn` and the record.\n\nActions must return one of the following:\n\n- `{:ok, record}` indicating the action was performed successfully.\n- `{:error, changeset}` indicating there was a validation error.\n- `{:error, record, custom_error}` to communicate a custom error message to the user where `custom_error` is a string.\n\n##","ref":"readme.html#single-resource-actions"},{"type":"extras","title":"List Actions - Overview","doc":"Kaffy also supports actions on a group of resources. You can enable list actions by defining `list_actions/1`.\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def list_actions(_conn) do\n    [\n      change_price: %{\n        name: \"Change the price\",\n        inputs: [\n          %{name: \"new_price\", title: \"New Price\", default: \"3\"}\n        ],\n        action: fn _conn, products, params -> change_price(products, params) end\n      },\n      soldout: %{name: \"Mark as soldout\", action: fn _, products -> list_soldout(products) end},\n      restock: %{name: \"Bring back\", action: fn _, products -> bring_back(products) end},\n      not_good: %{name: \"Error me out\", action: fn _, _ -> {:error, \"Expected error\"} end}\n    ]\n  end\n\n  defp change_price(products, params) do\n      new_price = Map.get(params, \"new_price\") |> Decimal.new()\n\n      Enum.map(products, fn p ->\n        Ecto.Changeset.change(p, %{price: new_price})\n        |> Bakery.Repo.update()\n      end)\n\n      :ok\n  end\nend\n```\n\nResult\n\n![List actions](assets/kaffy_list_actions.png)\n\n`list_actions/1` takes a `conn` and must return a keyword list.\nThe keys must be atoms defining the unique action \"keys\".\nThe values are maps providing a human-friendly `:name` and an `:action` that is an anonymous function with arity 2 that takes a `conn` and a list of selected records.\n\nThe `change_price` action is a multi-step action.\nThe defined `:inputs` option will display a popup with a form that contains defined in this option.\n`:inputs` should be a list of maps. Each input must have a `:name` and a `:title`.\nAn optional key in the input map is `:use_select`, which defaults to `false`.\nIf `true`, the input becomes a `select` instead by using a passed in list called `:options`, which is a list of lists formatted like so `[[display, value], [display, value]]`.\nIf `false`, a `:default` value is required for the text input.\nAfter submitting the popup form, the extra values, along with the selected resources, are passed to the `:action` function.\nIn the example above, `change_price/2` will receive the selected products with a map of extra inputs, like: `%{\"new_price\" => \"3.5\"}` for example.\n\n![MultiStep actions](assets/kaffy_multistep_actions.png)\n\nList actions must return one of the following:\n\n- `:ok` indicating the action was performed successfully.\n- `{:error, custom_error}` to communicate a custom error message to the user where `custom_error` is a string.\n\n#","ref":"readme.html#list-actions"},{"type":"extras","title":"Callbacks - Overview","doc":"Sometimes you need to execute certain actions when creating, updating, or deleting records.\n\nKaffy has your back.\n\nThere are a few callbacks that are called every time you create, update, or delete a record.\n\nThese callbacks are:\n\n- `before_insert/2`\n- `before_update/2`\n- `before_delete/2`\n- `before_save/2`\n- `after_save/2`\n- `after_delete/2`\n- `after_update/2`\n- `after_insert/2`\n\n`before_*` functions are passed the current `conn` and a changeset. `after_*` functions are passed the current `conn` and the record itself. With the exception of `before_delete/2` and `after_delete/2` which are both passed the current `conn` and the record itself.\n\n- `before_(create|save|update)/2` must return `{:ok, changeset}` to continue.\n- `before_delete/2` must return `{:ok, record}` to continue.\n- All `after_*` functions must return `{:ok, record}` to continue.\n\nTo prevent the chain from continuing and roll back any changes:\n\n- `before_(create|save|update)/2` must return `{:error, changeset}`.\n- `before_delete/2` must return `{:error, record, \"Customized error message}`.\n- All `after_*` functions must return `{:error, record, \"Customized error message\"}`.\n\nWhen creating a new record, the following functions are called in this order:\n\n- `before_insert/2`\n- `before_save/2`\n- inserting the record happens here: `Repo.insert/1`\n- `after_save/2`\n- `after_insert/2`\n\nWhen updating an existing record, the following functions are called in this order:\n\n- `before_update/2`\n- `before_save/2`\n- updating the record happens here: `Repo.update/1`\n- `after_save/2`\n- `after_update/2`\n\nWhen deleting a record, the following functions are called in this order:\n\n- `before_delete/2`\n- deleting the record happens here: `Repo.delete/1`\n- `after_delete/2`\n\nIt's important to know that all callbacks are run inside a transaction. So in case of failure, everything is rolled back even if the operation actually happened.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def before_insert(conn, changeset) do\n    case conn.assigns.user.username == \"aesmail\" do\n      true -> {:error, changeset} # aesmail should never create a post\n      false -> {:ok, changeset}\n    end\n  end\n\n  def after_insert(_conn, post) do\n    {:error, post, \"This will prevent posts from being created\"}\n  end\n\n  def before_delete(conn, post) do\n    case conn.assigns.user.role do\n      \"admin\" -> {:ok, post}\n      _ -> {:error, post, \"Only admins can delete posts\"}\n    end\n  end\nend\n```\n\n#","ref":"readme.html#callbacks"},{"type":"extras","title":"Overwrite actions - Overview","doc":"Sometimes you may need to overwrite the way Kaffy is creating, updating, or deleting records.\n\nYou can define you own Admin function to perform those actions. This can be useful if you are creating complex records, importing files, etc...\n\nThe function that can be overwritten are:\n\n- `insert/2`\n- `update/2`\n- `delete/2`\n\n`insert/2`, `update/2` & `delete/2` functions are passed the current `conn` and a changeset.\nThey must return `{:ok, record}` to continue.\n\n```elixir\ndefmodule MyApp.Blog.PostAdmin do\n  def insert(conn, changeset) do\n    entry = Post.create_complex_post(conn.params)\n    {:ok, entry}\n  end\n\n  def update(conn, changeset) do\n    entry = Post.update_complex_post(conn.params[\"id\"])\n    {:ok, entry}\n  end\n\n  def delete(conn, changeset) do\n    entry = Post.delete_complex_post(conn.params[\"id\"])\n    {:ok, entry}\n  end\nend\n```\n\n#","ref":"readme.html#overwrite-actions"},{"type":"extras","title":"Scheduled Tasks - Overview","doc":"Kaffy supports simple scheduled tasks. Tasks are functions that are run periodically. Behind the scenes, they are put inside `GenServer`s and supervised with a `DynamicSupervisor`.\n\nTo setup scheduled tasks, first define a `task_[task_name]/1` function in your admin module that returns a list of tasks:\n\n```elixir\ndefmodule MyApp.Products.ProductAdmin do\n  def task_products do\n    [\n      %{\n        name: \"Cache Product Count\",\n        initial_value: 0,\n        every: 15,\n        action: fn _v ->\n          count = Bakery.Products.cache_product_count()\n          # \"count\" will be passed to this function in its next run.\n          {:ok, count}\n        end\n      },\n      %{\n        name: \"Delete Fake Products\",\n        every: 60,\n        initial_value: nil,\n        action: fn _ ->\n          Bakery.Products.delete_fake_products()\n          {:ok, nil}\n        end\n      }\n    ]\n  end\nend\n```\n\nOnce this is done, add the admin module to the `scheduled_tasks` option in your config:\n```elixir\nconfig :kaffy,\n  ...\n  scheduled_tasks: [\n    MyApp.Products.ProductAdmin\n  ]\n\n```\n\nA new \"Tasks\" menu item will show up (below the Dashboard item) with your tasks as well as some tiny bits of information about each task like the following image:\n\n![Simple scheduled tasks](assets/kaffy_tasks.png)\n\nThe `task_[task_name]/1` function takes a schema and must return a list of tasks.\n\nA task is a map with the following keys:\n\n- `:name` to hold a short description for the task.\n- `:initial_value` to pass to the task's action in its first run.\n- `:every` to indicate the number of seconds between each run.\n- `:action` to hold an anonymous function with arity/1.\n\nThe `initial_value` is passed to the `action` function in its first run.\n\nThe `action` function must return one of the following values:\n\n- `{:ok, value}` which indicates a successful run. The `value` will be passed to the `action` function in its next run.\n- `{:error, value}` which indicates a failed run. The `value` will be saved and passed again to the `action` function in its next run.\n\nIf the `action` function crashes, the task will be brought back up again in its initial state that is defined in the `task_[task_name]/1` function and the \"Started\" time will change to indicate the new starting time. This will also reset the successful and failed run counts to 0.\n\nNote that since scheduled tasks are run with `GenServer`s, they are stored and kept in memory. Having too many scheduled tasks under low memory conditions can cause an out of memory exception.\n\nScheduled tasks should be used for simple, non-critical operations.","ref":"readme.html#scheduled-tasks"},{"type":"extras","title":"The Driving Points - Overview","doc":"A few points that encouraged the creation and development of Kaffy:\n\n- Taking contexts into account.\n  - Supporting contexts makes the admin interface better organized.\n- Can handle as many schemas as necessary.\n  - Whether we have 1 schema or 1000 schemas, the admin interface should adapt well.\n- Have a visually pleasant user interface.\n  - This might be subjective.\n- No generators or generated templates.\n  - I believe the less files there are the better. This also means it's easier to upgrade for users when releasing new versions. This might mean some flexibility and customizations will be lost, but it's a trade-off.\n- Existing schemas/contexts shouldn't have to be modified.\n  - I shouldn't have to change my code in order to adapt to the package, the package should adapt to my code.\n- Should be easy to use whether with a new project or with existing projects with a lot of schemas.\n  - Adding kaffy should be as easy for existing projects as it is for new ones.\n- Highly flexible and customizable.\n  - Provide as many configurable options as possible.\n- As few dependencies as possible.\n  - Currently kaffy only depends on Phoenix and Ecto.\n- Simple authorization.\n  - I need to limit access for some admins to some schemas.\n- Sensible, modifiable, default assumptions.\n  - When the package assumes something, this assumption should be sensible and modifiable when needed.","ref":"readme.html#the-driving-points"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2020 Abdullah Esmail\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}